diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/test/int64x64-test-suite.cc ns-3.41/src/core/test/int64x64-test-suite.cc
--- ns-3.40/src/core/test/int64x64-test-suite.cc	2023-09-27 13:30:37.634839000 -0700
+++ ns-3.41/src/core/test/int64x64-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
@@ -485,7 +485,7 @@
     const int64x64_t zero(0, 0);
     const int64x64_t one(1, 0);
     const int64x64_t two(2, 0);
-    const int64x64_t thre(3, 0);
+    const int64x64_t three(3, 0);
 
     std::cout << std::endl;
     std::cout << GetParent()->GetName() << " Arithmetic: " << GetName() << std::endl;
@@ -497,14 +497,14 @@
     Check(3, one - two, -one);
     Check(4, one - (-one), two);
     Check(5, (-one) - (-two), one);
-    Check(6, (-one) - two, -thre);
+    Check(6, (-one) - two, -three);
 
     Check(7, zero + zero, zero);
     Check(8, zero + one, one);
     Check(9, one + one, two);
-    Check(10, one + two, thre);
+    Check(10, one + two, three);
     Check(11, one + (-one), zero);
-    Check(12, (-one) + (-two), -thre);
+    Check(12, (-one) + (-two), -three);
     Check(13, (-one) + two, one);
 
     Check(14, zero * zero, zero);
@@ -514,7 +514,7 @@
     Check(18, one * (-one), -one);
     Check(19, (-one) * (-one), one);
 
-    Check(20, (two * thre) / thre, two);
+    Check(20, (two * three) / three, two);
     // NOLINTEND(misc-redundant-expression)
 
     const int64x64_t frac = int64x64_t(0, 0xc000000000000000ULL); // 0.75
@@ -526,7 +526,7 @@
     const int64x64_t zerof = zero + frac;
     const int64x64_t onef = one + frac;
     const int64x64_t twof = two + frac;
-    const int64x64_t thref = thre + frac;
+    const int64x64_t thref = three + frac;
 
     // NOLINTBEGIN(misc-redundant-expression)
     Check(23, zerof, frac);
@@ -559,11 +559,11 @@
     // NOLINTEND(misc-redundant-expression)
 
     // Multiplication followed by division is exact:
-    Check(46, (two * thre) / thre, two);
+    Check(46, (two * three) / three, two);
     Check(47, (twof * thref) / thref, twof);
 
     // Division followed by multiplication loses a bit or two:
-    Check(48, (two / thre) * thre, two, 2 * tol1);
+    Check(48, (two / three) * three, two, 2 * tol1);
     Check(49, (twof / thref) * thref, twof, 3 * tol1);
 
     // The example below shows that we really do not lose
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/test/matrix-array-test-suite.cc ns-3.41/src/core/test/matrix-array-test-suite.cc
--- ns-3.40/src/core/test/matrix-array-test-suite.cc	2023-09-27 13:30:37.634839000 -0700
+++ ns-3.41/src/core/test/matrix-array-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
@@ -44,21 +44,21 @@
 class MatrixArrayTestCase : public TestCase
 {
   public:
-    MatrixArrayTestCase<T>() = default;
+    MatrixArrayTestCase() = default;
     /**
      * Constructor
      *
      * \param [in] name reference name
      */
-    MatrixArrayTestCase<T>(const std::string& name);
+    MatrixArrayTestCase(const std::string& name);
 
     /** Destructor. */
-    ~MatrixArrayTestCase<T>() override;
+    ~MatrixArrayTestCase() override;
     /**
      * \brief Copy constructor.
      * Instruct the compiler to generate the implicitly declared copy constructor
      */
-    MatrixArrayTestCase<T>(const MatrixArrayTestCase<T>&) = default;
+    MatrixArrayTestCase(const MatrixArrayTestCase<T>&) = default;
     /**
      * \brief Copy assignment operator.
      * Instruct the compiler to generate the implicitly declared copy assignment operator.
@@ -69,7 +69,7 @@
      * \brief Move constructor.
      * Instruct the compiler to generate the implicitly declared move constructor
      */
-    MatrixArrayTestCase<T>(MatrixArrayTestCase<T>&&) = default;
+    MatrixArrayTestCase(MatrixArrayTestCase<T>&&) = default;
     /**
      * \brief Move assignment operator.
      * Instruct the compiler to generate the implicitly declared copy constructor
@@ -89,7 +89,7 @@
 }
 
 template <class T>
-MatrixArrayTestCase<T>::~MatrixArrayTestCase<T>()
+MatrixArrayTestCase<T>::~MatrixArrayTestCase()
 {
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/test/random-variable-stream-test-suite.cc ns-3.41/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.40/src/core/test/random-variable-stream-test-suite.cc	2023-09-27 13:30:37.634839000 -0700
+++ ns-3.41/src/core/test/random-variable-stream-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
@@ -34,6 +34,7 @@
 #include <fstream>
 #include <gsl/gsl_cdf.h>
 #include <gsl/gsl_histogram.h>
+#include <gsl/gsl_randist.h>
 #include <gsl/gsl_sf_zeta.h>
 
 using namespace ns3;
@@ -2567,6 +2568,312 @@
 
 /**
  * \ingroup rng-tests
+ * Test case for bernoulli distribution random variable stream generator
+ */
+class BernoulliTestCase : public TestCaseBase
+{
+  public:
+    // Constructor
+    BernoulliTestCase();
+
+    // Inherited
+    double ChiSquaredTest(Ptr<RandomVariableStream> rng) const override;
+
+  private:
+    // Inherited
+    void DoRun() override;
+
+    /** Tolerance for testing rng values against expectation, in rms. */
+    static constexpr double TOLERANCE{5};
+};
+
+BernoulliTestCase::BernoulliTestCase()
+    : TestCaseBase("Bernoulli Random Variable Stream Generator")
+{
+}
+
+double
+BernoulliTestCase::ChiSquaredTest(Ptr<RandomVariableStream> rng) const
+{
+    gsl_histogram* h = gsl_histogram_alloc(2);
+    auto range = UniformHistogramBins(h, 0, 1);
+
+    double p = 0.5;
+    std::vector<double> expected = {N_MEASUREMENTS * (1 - p), N_MEASUREMENTS * p};
+
+    double chiSquared = ChiSquared(h, expected, rng);
+
+    gsl_histogram_free(h);
+    return chiSquared;
+}
+
+void
+BernoulliTestCase::DoRun()
+{
+    NS_LOG_FUNCTION(this);
+    SetTestSuiteSeed();
+
+    auto generator = RngGenerator<BernoulliRandomVariable>();
+    double sum = ChiSquaredsAverage(&generator, N_RUNS);
+    double maxStatistic = gsl_cdf_chisq_Qinv(0.05, 1);
+    NS_TEST_ASSERT_MSG_LT(sum, maxStatistic, "Chi-squared statistic out of range");
+
+    double probability = 0.5;
+
+    // Create the RNG with the specified range.
+    Ptr<BernoulliRandomVariable> x = CreateObject<BernoulliRandomVariable>();
+    x->SetAttribute("Probability", DoubleValue(probability));
+
+    // Calculate the mean of these values.
+    double mean = probability;
+    double valueMean = Average(x);
+    double expectedMean = mean;
+    double expectedRms = std::sqrt(mean / N_MEASUREMENTS);
+
+    // Test that values have approximately the right mean value.
+    NS_TEST_ASSERT_MSG_EQ_TOL(valueMean,
+                              expectedMean,
+                              expectedRms * TOLERANCE,
+                              "Wrong mean value.");
+}
+
+/**
+ * \ingroup rng-tests
+ * Test case for antithetic bernoulli distribution random variable stream generator
+ */
+class BernoulliAntitheticTestCase : public TestCaseBase
+{
+  public:
+    // Constructor
+    BernoulliAntitheticTestCase();
+
+    // Inherited
+    double ChiSquaredTest(Ptr<RandomVariableStream> rng) const override;
+
+  private:
+    // Inherited
+    void DoRun() override;
+
+    /** Tolerance for testing rng values against expectation, in rms. */
+    static constexpr double TOLERANCE{5};
+};
+
+BernoulliAntitheticTestCase::BernoulliAntitheticTestCase()
+    : TestCaseBase("Antithetic Bernoulli Random Variable Stream Generator")
+{
+}
+
+double
+BernoulliAntitheticTestCase::ChiSquaredTest(Ptr<RandomVariableStream> rng) const
+{
+    gsl_histogram* h = gsl_histogram_alloc(2);
+    auto range = UniformHistogramBins(h, 0, 1);
+
+    double p = 0.5;
+    std::vector<double> expected = {N_MEASUREMENTS * (1 - p), N_MEASUREMENTS * p};
+
+    double chiSquared = ChiSquared(h, expected, rng);
+
+    gsl_histogram_free(h);
+    return chiSquared;
+}
+
+void
+BernoulliAntitheticTestCase::DoRun()
+{
+    NS_LOG_FUNCTION(this);
+    SetTestSuiteSeed();
+
+    auto generator = RngGenerator<BernoulliRandomVariable>(true);
+    double sum = ChiSquaredsAverage(&generator, N_RUNS);
+    double maxStatistic = gsl_cdf_chisq_Qinv(0.05, 1);
+    NS_TEST_ASSERT_MSG_LT(sum, maxStatistic, "Chi-squared statistic out of range");
+
+    double probability = 0.5;
+
+    // Create the RNG with the specified range.
+    Ptr<BernoulliRandomVariable> x = CreateObject<BernoulliRandomVariable>();
+    x->SetAttribute("Probability", DoubleValue(probability));
+
+    // Make this generate antithetic values.
+    x->SetAttribute("Antithetic", BooleanValue(true));
+
+    // Calculate the mean of these values.
+    double mean = probability;
+    double valueMean = Average(x);
+    double expectedMean = mean;
+    double expectedRms = std::sqrt(mean / N_MEASUREMENTS);
+
+    // Test that values have approximately the right mean value.
+    NS_TEST_ASSERT_MSG_EQ_TOL(valueMean,
+                              expectedMean,
+                              expectedRms * TOLERANCE,
+                              "Wrong mean value.");
+}
+
+/**
+ * \ingroup rng-tests
+ * Test case for binomial distribution random variable stream generator
+ */
+class BinomialTestCase : public TestCaseBase
+{
+  public:
+    // Constructor
+    BinomialTestCase();
+
+    // Inherited
+    double ChiSquaredTest(Ptr<RandomVariableStream> rng) const override;
+
+  private:
+    // Inherited
+    void DoRun() override;
+
+    /** Tolerance for testing rng values against expectation, in rms. */
+    static constexpr double TOLERANCE{5};
+};
+
+BinomialTestCase::BinomialTestCase()
+    : TestCaseBase("Binomial Random Variable Stream Generator")
+{
+}
+
+double
+BinomialTestCase::ChiSquaredTest(Ptr<RandomVariableStream> rng) const
+{
+    uint32_t trials = 10;
+    double probability = 0.5;
+
+    gsl_histogram* h = gsl_histogram_alloc(trials + 1);
+    auto range = UniformHistogramBins(h, 0, trials);
+
+    std::vector<double> expected(trials + 1);
+    for (std::size_t i = 0; i < trials + 1; ++i)
+    {
+        expected[i] = N_MEASUREMENTS * gsl_ran_binomial_pdf(i, probability, trials);
+    }
+
+    double chiSquared = ChiSquared(h, expected, rng);
+
+    gsl_histogram_free(h);
+    return chiSquared;
+}
+
+void
+BinomialTestCase::DoRun()
+{
+    NS_LOG_FUNCTION(this);
+    SetTestSuiteSeed();
+
+    uint32_t trials = 10;
+    double probability = 0.5;
+
+    auto generator = RngGenerator<BinomialRandomVariable>();
+    double sum = ChiSquaredsAverage(&generator, N_RUNS);
+    double maxStatistic = gsl_cdf_chisq_Qinv(0.05, trials);
+    NS_TEST_ASSERT_MSG_LT(sum, maxStatistic, "Chi-squared statistic out of range");
+
+    // Create the RNG with the specified range.
+    Ptr<BinomialRandomVariable> x = CreateObject<BinomialRandomVariable>();
+    x->SetAttribute("Trials", IntegerValue(trials));
+    x->SetAttribute("Probability", DoubleValue(probability));
+
+    // Calculate the mean of these values.
+    double mean = trials * probability;
+    double valueMean = Average(x);
+    double expectedMean = mean;
+    double expectedRms = std::sqrt(mean / N_MEASUREMENTS);
+
+    // Test that values have approximately the right mean value.
+    NS_TEST_ASSERT_MSG_EQ_TOL(valueMean,
+                              expectedMean,
+                              expectedRms * TOLERANCE,
+                              "Wrong mean value.");
+}
+
+/**
+ * \ingroup rng-tests
+ * Test case for antithetic binomial distribution random variable stream generator
+ */
+class BinomialAntitheticTestCase : public TestCaseBase
+{
+  public:
+    // Constructor
+    BinomialAntitheticTestCase();
+
+    // Inherited
+    double ChiSquaredTest(Ptr<RandomVariableStream> rng) const override;
+
+  private:
+    // Inherited
+    void DoRun() override;
+
+    /** Tolerance for testing rng values against expectation, in rms. */
+    static constexpr double TOLERANCE{5};
+};
+
+BinomialAntitheticTestCase::BinomialAntitheticTestCase()
+    : TestCaseBase("Antithetic Binomial Random Variable Stream Generator")
+{
+}
+
+double
+BinomialAntitheticTestCase::ChiSquaredTest(Ptr<RandomVariableStream> rng) const
+{
+    uint32_t trials = 10;
+    double probability = 0.5;
+
+    gsl_histogram* h = gsl_histogram_alloc(trials + 1);
+    auto range = UniformHistogramBins(h, 0, trials);
+
+    std::vector<double> expected(trials + 1);
+    for (std::size_t i = 0; i < trials + 1; ++i)
+    {
+        expected[i] = N_MEASUREMENTS * gsl_ran_binomial_pdf(i, probability, trials);
+    }
+
+    double chiSquared = ChiSquared(h, expected, rng);
+
+    gsl_histogram_free(h);
+    return chiSquared;
+}
+
+void
+BinomialAntitheticTestCase::DoRun()
+{
+    NS_LOG_FUNCTION(this);
+    SetTestSuiteSeed();
+
+    uint32_t trials = 10;
+    double probability = 0.5;
+
+    auto generator = RngGenerator<BinomialRandomVariable>(true);
+    double sum = ChiSquaredsAverage(&generator, N_RUNS);
+    double maxStatistic = gsl_cdf_chisq_Qinv(0.05, trials);
+    NS_TEST_ASSERT_MSG_LT(sum, maxStatistic, "Chi-squared statistic out of range");
+
+    // Create the RNG with the specified range.
+    Ptr<BinomialRandomVariable> x = CreateObject<BinomialRandomVariable>();
+    x->SetAttribute("Trials", IntegerValue(trials));
+    x->SetAttribute("Probability", DoubleValue(probability));
+
+    // Make this generate antithetic values.
+    x->SetAttribute("Antithetic", BooleanValue(true));
+
+    // Calculate the mean of these values.
+    double mean = trials * probability;
+    double valueMean = Average(x);
+    double expectedMean = mean;
+    double expectedRms = std::sqrt(mean / N_MEASUREMENTS);
+
+    // Test that values have approximately the right mean value.
+    NS_TEST_ASSERT_MSG_EQ_TOL(valueMean,
+                              expectedMean,
+                              expectedRms * TOLERANCE,
+                              "Wrong mean value.");
+}
+
+/**
+ * \ingroup rng-tests
  * RandomVariableStream test suite, covering all random number variable
  * stream generator types.
  */
@@ -2617,6 +2924,10 @@
     AddTestCase(new EmpiricalAntitheticTestCase);
     /// Issue #302:  NormalRandomVariable produces stale values
     AddTestCase(new NormalCachingTestCase);
+    AddTestCase(new BernoulliTestCase);
+    AddTestCase(new BernoulliAntitheticTestCase);
+    AddTestCase(new BinomialTestCase);
+    AddTestCase(new BinomialAntitheticTestCase);
 }
 
 static RandomVariableSuite randomVariableSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/test/tuple-value-test-suite.cc ns-3.41/src/core/test/tuple-value-test-suite.cc
--- ns-3.40/src/core/test/tuple-value-test-suite.cc	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/core/test/tuple-value-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
@@ -62,8 +62,9 @@
 
     // NOTE EnumValue::Get() return an int, so the tuple element type must be an int
     // in place of the enum type
-    using Tuple1Value = TupleValue<StringValue, StringValue, EnumValue>; //!< Tuple1 attribute value
-    using Tuple1 = Tuple1Value::result_type;                             //!< tuple of values
+    using Tuple1Value =
+        TupleValue<StringValue, StringValue, EnumValue<TupleTestEnum>>; //!< Tuple1 attribute value
+    using Tuple1 = Tuple1Value::result_type;                            //!< tuple of values
     using Tuple1Pack = Tuple1Value::value_type; //!< tuple of attribute values
 
     using Tuple2 = std::tuple<double, uint16_t, std::string>; //!< Tuple2 typedef
@@ -207,7 +208,7 @@
             TupleObject::Tuple1{"Norwegian", "Wood", TupleObject::VALUE2}));
     NS_TEST_ASSERT_MSG_EQ(ret1, true, "Setting valid values to tuple 1 failed");
 
-    TupleValue<StringValue, StringValue, EnumValue> tupleValue1;
+    TupleValue<StringValue, StringValue, EnumValue<TupleObject::TupleTestEnum>> tupleValue1;
     ret1 = tupleObject->GetAttributeFailSafe("StringStringEnumTuple", tupleValue1);
     NS_TEST_ASSERT_MSG_EQ(ret1, true, "Getting values for tuple 1 failed");
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/core/test/val-array-test-suite.cc ns-3.41/src/core/test/val-array-test-suite.cc
--- ns-3.40/src/core/test/val-array-test-suite.cc	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/core/test/val-array-test-suite.cc	2024-02-09 14:44:07.893790000 -0800
@@ -42,21 +42,21 @@
 {
   public:
     /** Default constructor*/
-    ValArrayTestCase<T>() = default;
+    ValArrayTestCase() = default;
     /**
      * Constructor
      *
      * \param [in] name reference name
      */
-    ValArrayTestCase<T>(const std::string& name);
+    ValArrayTestCase(const std::string& name);
 
     /** Destructor. */
-    ~ValArrayTestCase<T>() override;
+    ~ValArrayTestCase() override;
     /**
      * \brief Copy constructor.
      * Instruct the compiler to generate the implicitly declared copy constructor
      */
-    ValArrayTestCase<T>(const ValArrayTestCase<T>&) = default;
+    ValArrayTestCase(const ValArrayTestCase<T>&) = default;
     /**
      * \brief Copy assignment operator.
      * Instruct the compiler to generate the implicitly declared copy assignment operator.
@@ -67,7 +67,7 @@
      * \brief Move constructor.
      * Instruct the compiler to generate the implicitly declared move constructor
      */
-    ValArrayTestCase<T>(ValArrayTestCase<T>&&) = default;
+    ValArrayTestCase(ValArrayTestCase<T>&&) = default;
     /**
      * \brief Move assignment operator.
      * Instruct the compiler to generate the implicitly declared copy constructor
@@ -86,7 +86,7 @@
 }
 
 template <class T>
-ValArrayTestCase<T>::~ValArrayTestCase<T>()
+ValArrayTestCase<T>::~ValArrayTestCase()
 {
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/csma/CMakeLists.txt ns-3.41/src/csma/CMakeLists.txt
--- ns-3.40/src/csma/CMakeLists.txt	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/csma/CMakeLists.txt	2024-02-09 14:44:07.893790000 -0800
@@ -11,5 +11,4 @@
     model/csma-channel.h
     model/csma-net-device.h
   LIBRARIES_TO_LINK ${libnetwork}
-  TEST_SOURCES ${test_sources}
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/csma/model/csma-channel.cc ns-3.41/src/csma/model/csma-channel.cc
--- ns-3.40/src/csma/model/csma-channel.cc	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/csma/model/csma-channel.cc	2024-02-09 14:44:07.897790000 -0800
@@ -191,7 +191,7 @@
     }
 
     NS_LOG_LOGIC("switch to TRANSMITTING");
-    m_currentPkt = p->Copy();
+    m_currentPkt = p;
     m_currentSrc = srcId;
     m_state = TRANSMITTING;
     return true;
@@ -200,7 +200,7 @@
 bool
 CsmaChannel::IsActive(uint32_t deviceId)
 {
-    return (m_deviceList[deviceId].active);
+    return m_deviceList[deviceId].active;
 }
 
 bool
@@ -234,7 +234,7 @@
                                            m_delay,
                                            &CsmaNetDevice::Receive,
                                            it->devicePtr,
-                                           m_currentPkt->Copy(),
+                                           m_currentPkt,
                                            m_deviceList[m_currentSrc].devicePtr);
         }
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/csma/model/csma-channel.h ns-3.41/src/csma/model/csma-channel.h
--- ns-3.40/src/csma/model/csma-channel.h	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/csma/model/csma-channel.h	2024-02-09 14:44:07.897790000 -0800
@@ -325,7 +325,7 @@
      * packet to have been transmitted on the channel if the channel is
      * free.)
      */
-    Ptr<Packet> m_currentPkt;
+    Ptr<const Packet> m_currentPkt;
 
     /**
      * Device Id of the source that is currently transmitting on the
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/csma/model/csma-net-device.cc ns-3.41/src/csma/model/csma-net-device.cc
--- ns-3.40/src/csma/model/csma-net-device.cc	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/csma/model/csma-net-device.cc	2024-02-09 14:44:07.897790000 -0800
@@ -62,7 +62,7 @@
             .AddAttribute("EncapsulationMode",
                           "The link-layer encapsulation type to use.",
                           EnumValue(DIX),
-                          MakeEnumAccessor(&CsmaNetDevice::SetEncapsulationMode),
+                          MakeEnumAccessor<EncapsulationMode>(&CsmaNetDevice::SetEncapsulationMode),
                           MakeEnumChecker(DIX, "Dix", LLC, "Llc"))
             .AddAttribute("SendEnable",
                           "Enable or disable the transmitter section of the device.",
@@ -695,7 +695,7 @@
 }
 
 void
-CsmaNetDevice::Receive(Ptr<Packet> packet, Ptr<CsmaNetDevice> senderDevice)
+CsmaNetDevice::Receive(Ptr<const Packet> packet, Ptr<CsmaNetDevice> senderDevice)
 {
     NS_LOG_FUNCTION(packet << senderDevice);
     NS_LOG_LOGIC("UID is " << packet->GetUid());
@@ -724,7 +724,9 @@
         return;
     }
 
-    if (m_receiveErrorModel && m_receiveErrorModel->IsCorrupt(packet))
+    Ptr<Packet> pktCopy = packet->Copy();
+
+    if (m_receiveErrorModel && m_receiveErrorModel->IsCorrupt(pktCopy))
     {
         NS_LOG_LOGIC("Dropping pkt due to error model ");
         m_phyRxDropTrace(packet);
@@ -735,16 +737,15 @@
     // Trace sinks will expect complete packets, not packets without some of the
     // headers.
     //
-    Ptr<Packet> originalPacket = packet->Copy();
 
     EthernetTrailer trailer;
-    packet->RemoveTrailer(trailer);
+    pktCopy->RemoveTrailer(trailer);
     if (Node::ChecksumEnabled())
     {
         trailer.EnableFcs(true);
     }
 
-    bool crcGood = trailer.CheckFcs(packet);
+    bool crcGood = trailer.CheckFcs(pktCopy);
     if (!crcGood)
     {
         NS_LOG_INFO("CRC error on Packet " << packet);
@@ -753,7 +754,7 @@
     }
 
     EthernetHeader header(false);
-    packet->RemoveHeader(header);
+    pktCopy->RemoveHeader(header);
 
     NS_LOG_LOGIC("Pkt source is " << header.GetSource());
     NS_LOG_LOGIC("Pkt destination is " << header.GetDestination());
@@ -767,16 +768,16 @@
     //
     if (header.GetLengthType() <= 1500)
     {
-        NS_ASSERT(packet->GetSize() >= header.GetLengthType());
-        uint32_t padlen = packet->GetSize() - header.GetLengthType();
+        NS_ASSERT(pktCopy->GetSize() >= header.GetLengthType());
+        uint32_t padlen = pktCopy->GetSize() - header.GetLengthType();
         NS_ASSERT(padlen <= 46);
         if (padlen > 0)
         {
-            packet->RemoveAtEnd(padlen);
+            pktCopy->RemoveAtEnd(padlen);
         }
 
         LlcSnapHeader llc;
-        packet->RemoveHeader(llc);
+        pktCopy->RemoveHeader(llc);
         protocol = llc.GetType();
     }
     else
@@ -811,12 +812,12 @@
     // hook and pass a copy up to the promiscuous callback.  Pass a copy to
     // make sure that nobody messes with our packet.
     //
-    m_promiscSnifferTrace(originalPacket);
+    m_promiscSnifferTrace(packet);
     if (!m_promiscRxCallback.IsNull())
     {
-        m_macPromiscRxTrace(originalPacket);
+        m_macPromiscRxTrace(packet);
         m_promiscRxCallback(this,
-                            packet,
+                            pktCopy,
                             protocol,
                             header.GetSource(),
                             header.GetDestination(),
@@ -830,9 +831,9 @@
     //
     if (packetType != PACKET_OTHERHOST)
     {
-        m_snifferTrace(originalPacket);
-        m_macRxTrace(originalPacket);
-        m_rxCallback(this, packet, protocol, header.GetSource());
+        m_snifferTrace(packet);
+        m_macRxTrace(packet);
+        m_rxCallback(this, pktCopy, protocol, header.GetSource());
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/csma/model/csma-net-device.h ns-3.41/src/csma/model/csma-net-device.h
--- ns-3.40/src/csma/model/csma-net-device.h	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/csma/model/csma-net-device.h	2024-02-09 14:44:07.897790000 -0800
@@ -172,7 +172,7 @@
      * \param p a reference to the received packet
      * \param sender the CsmaNetDevice that transmitted the packet in the first place
      */
-    void Receive(Ptr<Packet> p, Ptr<CsmaNetDevice> sender);
+    void Receive(Ptr<const Packet> p, Ptr<CsmaNetDevice> sender);
 
     /**
      * Is the send side of the network device enabled?
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/csma-layout/CMakeLists.txt ns-3.41/src/csma-layout/CMakeLists.txt
--- ns-3.40/src/csma-layout/CMakeLists.txt	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/csma-layout/CMakeLists.txt	2024-02-09 14:44:07.893790000 -0800
@@ -3,7 +3,6 @@
   SOURCE_FILES model/csma-star-helper.cc
   HEADER_FILES model/csma-star-helper.h
   LIBRARIES_TO_LINK
-    ${libnetwork}
     ${libinternet}
     ${libcsma}
     ${libpoint-to-point}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/dsdv/CMakeLists.txt ns-3.41/src/dsdv/CMakeLists.txt
--- ns-3.40/src/dsdv/CMakeLists.txt	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/dsdv/CMakeLists.txt	2024-02-09 14:44:07.897790000 -0800
@@ -12,6 +12,7 @@
     model/dsdv-packet.h
     model/dsdv-routing-protocol.h
     model/dsdv-rtable.h
-  LIBRARIES_TO_LINK ${libinternet}
+  LIBRARIES_TO_LINK ${libmesh}
+                    ${libinternet-apps}
   TEST_SOURCES test/dsdv-testcase.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/dsdv/model/dsdv-routing-protocol.cc ns-3.41/src/dsdv/model/dsdv-routing-protocol.cc
--- ns-3.40/src/dsdv/model/dsdv-routing-protocol.cc	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/dsdv/model/dsdv-routing-protocol.cc	2024-02-09 14:44:07.897790000 -0800
@@ -932,7 +932,7 @@
             else
             {
                 dsdvHeader.SetDst(i->second.GetDestination());
-                dsdvHeader.SetDstSeqno((i->second.GetSeqNo()));
+                dsdvHeader.SetDstSeqno(i->second.GetSeqNo());
                 dsdvHeader.SetHopCount(i->second.GetHop() + 1);
                 packet->AddHeader(dsdvHeader);
             }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/dsdv/model/dsdv-rtable.h ns-3.41/src/dsdv/model/dsdv-rtable.h
--- ns-3.40/src/dsdv/model/dsdv-rtable.h	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/dsdv/model/dsdv-rtable.h	2024-02-09 14:44:07.897790000 -0800
@@ -233,7 +233,7 @@
      */
     Time GetSettlingTime() const
     {
-        return (m_settlingTime);
+        return m_settlingTime;
     }
 
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/dsdv/test/dsdv-testcase.cc ns-3.41/src/dsdv/test/dsdv-testcase.cc
--- ns-3.40/src/dsdv/test/dsdv-testcase.cc	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/dsdv/test/dsdv-testcase.cc	2024-02-09 14:44:07.897790000 -0800
@@ -41,7 +41,6 @@
 #include "ns3/string.h"
 #include "ns3/test.h"
 #include "ns3/uinteger.h"
-#include "ns3/v4ping-helper.h"
 
 using namespace ns3;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/dsr/CMakeLists.txt ns-3.41/src/dsr/CMakeLists.txt
--- ns-3.40/src/dsr/CMakeLists.txt	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/dsr/CMakeLists.txt	2024-02-09 14:44:07.897790000 -0800
@@ -30,7 +30,6 @@
     model/dsr-routing.h
     model/dsr-rreq-table.h
     model/dsr-rsendbuff.h
-  LIBRARIES_TO_LINK ${libinternet}
-                    ${libwifi}
+  LIBRARIES_TO_LINK ${libmesh}
   TEST_SOURCES test/dsr-test-suite.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/dsr/examples/dsr.cc ns-3.41/src/dsr/examples/dsr.cc
--- ns-3.40/src/dsr/examples/dsr.cc	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/dsr/examples/dsr.cc	2024-02-09 14:44:07.897790000 -0800
@@ -29,7 +29,6 @@
  */
 
 #include "ns3/applications-module.h"
-#include "ns3/config-store-module.h"
 #include "ns3/core-module.h"
 #include "ns3/dsr-module.h"
 #include "ns3/internet-module.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/dsr/model/dsr-options.cc ns-3.41/src/dsr/model/dsr-options.cc
--- ns-3.40/src/dsr/model/dsr-options.cc	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/dsr/model/dsr-options.cc	2024-02-09 14:44:07.901790100 -0800
@@ -755,7 +755,7 @@
                     //   {
                     //     dsr->UseExtends (m_finalRoute);
                     //   }
-                    sourceRoute.SetSegmentsLeft((m_finalRoute.size() - 2));
+                    sourceRoute.SetSegmentsLeft(m_finalRoute.size() - 2);
                     // The salvage value here is 0
                     sourceRoute.SetSalvage(0);
                     Ipv4Address nextHop =
@@ -860,7 +860,7 @@
                     //   {
                     //     dsr->UseExtends (saveRoute);
                     //   }
-                    sourceRoute.SetSegmentsLeft((saveRoute.size() - 2));
+                    sourceRoute.SetSegmentsLeft(saveRoute.size() - 2);
                     uint8_t salvage = 0;
                     sourceRoute.SetSalvage(salvage);
                     Ipv4Address nextHop =
@@ -1123,7 +1123,7 @@
             DsrOptionSRHeader sourceRoute;
             NS_LOG_DEBUG("The route length " << nodeList.size());
             sourceRoute.SetNodesAddress(nodeList);
-            sourceRoute.SetSegmentsLeft((nodeList.size() - 2));
+            sourceRoute.SetSegmentsLeft(nodeList.size() - 2);
             sourceRoute.SetSalvage(0);
             Ipv4Address nextHop = SearchNextHop(ipv4Address, nodeList); // Get the next hop address
             NS_LOG_DEBUG("The nextHop address " << nextHop);
@@ -1759,7 +1759,7 @@
     DsrOptionAckReqHeader ackReq;
     p->RemoveHeader(ackReq);
     /*
-     * Get the node with ip address and get the dsr extension and reoute cache objects
+     * Get the node with ip address and get the dsr extension and route cache objects
      */
     Ptr<Node> node = GetNodeWithAddress(ipv4Address);
     Ptr<dsr::DsrRouting> dsr = node->GetObject<dsr::DsrRouting>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/src/dsr/model/dsr-rcache.h ns-3.41/src/dsr/model/dsr-rcache.h
--- ns-3.40/src/dsr/model/dsr-rcache.h	2023-09-27 13:30:37.638839000 -0700
+++ ns-3.41/src/dsr/model/dsr-rcache.h	2024-02-09 14:44:07.901790100 -0800
@@ -345,41 +345,15 @@
     void Print(std::ostream& os) const;
 
     /**
-     * \brief Compare the route cache entry
+     * \brief Compare the route cache entry. Only the paths are compared.
      * \param o entry to compare
-     * \return true if equal
+     * \return true if both route cache entries are equal
      */
     bool operator==(const DsrRouteCacheEntry& o) const
     {
-        if (m_path.size() != o.m_path.size())
-        {
-            NS_ASSERT(false);
-            return false;
-        }
-        auto j = o.m_path.begin();
-        for (auto i = m_path.begin(); i != m_path.end(); i++, j++)
-        {
-            /*
-             * Verify if neither the entry are not 0 and they equal to each other
-             */
-            if (((*i) == nullptr) || ((*j) == nullptr))
-            {
-                return false;
-            }
-            else if (!((*i) == (*j)))
-            {
-                return false;
-            }
-            else
-            {
-                return true;
-            }
-        }
-        return false;
+        return m_path == o.m_path;
     }
 
-    // \}
-
   private:
     Timer m_ackTimer;             ///< RREP_ACK timer
     Ipv4Address m_dst;            ///< The destination Ip address
